@@ -170,6 +170,7 @@ export WIPEFS_PROG="$(type -P wipefs)"
export DUMP_PROG="$(type -P dump)"
export RESTORE_PROG="$(type -P restore)"
export LVM_PROG="$(type -P lvm)"
+export LSATTR_PROG="$(type -P lsattr)"
export CHATTR_PROG="$(type -P chattr)"
export DEBUGFS_PROG="$(type -P debugfs)"
export UUIDGEN_PROG="$(type -P uuidgen)"
new file mode 100755
@@ -0,0 +1,97 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+#
+# FS QA Test 506
+#
+# This testcase is trying to test recovery flow of generic filesystem, w/ below
+# steps, once project id changes, after we fsync that file, we can expect that
+# project id can be recovered after sudden power-cuts.
+# 1. touch testfile;
+# 1.1 sync (optional)
+# 2. chattr -p 100 testfile;
+# 3. xfs_io -f testfile -c "fsync";
+# 4. godown;
+# 5. umount;
+# 6. mount;
+# 7. check project id
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_command "$LSATTR_PROG" lsattr
+_require_command "$CHATTR_PROG" chattr
+
+_require_prjquota $SCRATCH_DEV
+_require_scratch
+_require_scratch_shutdown
+
+_scratch_mkfs >/dev/null 2>&1
+_require_metadata_journaling $SCRATCH_DEV
+
+testfile=$SCRATCH_MNT/testfile
+
+do_check()
+{
+ _scratch_mount
+
+ touch $testfile
+
+ if [ "$1" == "sync" ]; then
+ sync
+ fi
+
+ $CHATTR_PROG -p 100 $testfile
+
+ before=`$LSATTR_PROG -p $testfile`
+
+ $XFS_IO_PROG -f $testfile -c "fsync" | _filter_xfs_io
+
+ _scratch_shutdown | tee -a $seqres.full
+ _scratch_cycle_mount
+
+ after=`$LSATTR_PROG -p $testfile`
+
+ # check inode's project quota id
+ if [ "$before" != "$after" ]; then
+ echo "Before: $before"
+ echo "After : $after"
+ fi
+ echo "Before: $before" >> $seqres.full
+ echo "After : $after" >> $seqres.full
+
+ rm -f $testfile
+ _scratch_unmount
+}
+
+echo "Silence is golden"
+
+do_check
+do_check sync
+
+status=0
+exit
new file mode 100644
@@ -0,0 +1,2 @@
+QA output created by 506
+Silence is golden
@@ -508,3 +508,4 @@
503 auto quick dax punch collapse zero
504 auto quick locks
505 shutdown auto quick metadata
+506 shutdown auto quick metadata quota